﻿//+--------------------------------------------------------------------------+
//|                                                                          |
//|                            DDWcontrol class                              |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                           copyright (c) 2006                             |
//|                                                                          |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//|                          www.zapsolution.com                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 11-12-2006 (MM-DD-YYYY)            |
//|                        Last revised : 11-12-2006 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using Win32;

namespace Carousel
{
    public partial class DDWcontrol : UserControl
    {
        public DDWcontrol()
        {
            InitializeComponent();
        }

        public void SHOW(byte Opacity) // Aka WinDev GFI/DDW
        {
            Api.RECT rw = new Api.RECT();
            Api.GetWindowRect(this.Parent.Handle, ref rw);
            int x = rw.left, y = rw.top, w = rw.right - rw.left, h = rw.bottom - rw.top;

            Bitmap bmpBack = new Bitmap(w, h);
            Graphics g = Graphics.FromImage(bmpBack);
            if (g != null)
            {
                // First capture the window
                IntPtr hDCDest = g.GetHdc();
                IntPtr hDeskTop = Api.GetDesktopWindow();
                int hDCSrce = Api.GetWindowDC(hDeskTop);
                Api.BitBlt((int)hDCDest, (int)0, (int)0, w, h, (int)hDCSrce, x, y, Api.SRCCOPY);
                Api.ReleaseDC(hDeskTop, hDCSrce);
                if (hDCDest != IntPtr.Zero) g.ReleaseHdc(hDCDest);
                g.Dispose();

                // Second apply opacity
                g = Graphics.FromImage(bmpBack);
                // Note: you can customize ARGB color to use something else than black
                SolidBrush myBrush = new SolidBrush(Color.FromArgb(Opacity, 0, 0, 0));
                g.FillRectangle(myBrush, 0, 0, w, h);
                myBrush.Dispose();
                g.Dispose();
            }
            this.Left = 0; this.Top = 0;
            this.Width = w; this.Height = h;
            this.BackgroundImage = bmpBack;
            this.BringToFront();
            this.Visible = true;
        }

        public void HIDE()
        {
            this.Visible = false; this.Width = 0; this.Height = 0;
            this.BackgroundImage.Dispose();
        }

    }
}
